<?php
/* =========================================================================
WordPress Gatekeeper
(cc) 2005  Eric A. Meyer  http://meyerweb.com/
========================================================================= */

require_once '../wp-config.php';

$title = 'Gatekeeper';
//$this_file = 'gatekeeper.php';

$tablechallenges = $table_prefix.'gatekeeper_challenges';
$tablefieldnames = $table_prefix.'gatekeeper_fieldnames';
$date_append = 'j M Y - g:i:s a';

function base_styles() {
echo <<<STYLE
<style type="text/css">
.wrap h3 {border-bottom: 1px dotted #AAA;}
#limiter {margin: -2.4em 0 1.2em; text-align: right;}
.wrap table {width: 100%;}
.wrap th, .wrap td {padding: 3px;}
th {text-align: left;}
.id {width: 1.5em; text-align: right;}
.pass {width: 6em;}
td.pass {font-family: "Andale Mono", "Courier New", Courier, monospace;}
tbody th {text-align: right;}
.adddate, .moddate {width: 12em;}

.a {float: left; width: 63%; margin-right: 0;}
.b {float: right; width: 20%; margin-left: 0;}
#footer {clear: both;}
</style>
STYLE;
}

function add_magic_quotes($array) {
	foreach ($array as $k => $v) {
		if (is_array($v)) {
			$array[$k] = add_magic_quotes($v);
		} else {
			$array[$k] = addslashes($v);
		}
	}
	return $array;
}

if (!get_magic_quotes_gpc()) {
	$HTTP_GET_VARS	= add_magic_quotes($HTTP_GET_VARS);
	$HTTP_POST_VARS   = add_magic_quotes($HTTP_POST_VARS);
	$HTTP_COOKIE_VARS = add_magic_quotes($HTTP_COOKIE_VARS);
}


if (!isset($_REQUEST['action'])) {
	add_action('admin_head','base_styles');
	include_once('admin-header.php');
?>

<div class="wrap">
<h2>Gatekeeper</h2>
<p>
Keep in mind that the point is to write questions and answers are completely obvious to a human.  Answers can be capitalized however you like, as they are checked case-insensitively when the user posts, so "Orange" and "orange" are treated as being the same.
</p>
  <h3>Challenges</h3>
  <?php
	if ($_REQUEST['show'] == 'all') {
		echo '<p id="limiter"><a href="gatekeeper.php">Most recent 10</a> | Complete list</p>';
	} else {
		echo '<p id="limiter">Most recent 10 | <a href="gatekeeper.php?show=all">Complete list</a></p>';
	}
  ?>
  <table cellspacing="1">
	<thead>
	<tr>
	  <th>ID</th>
	  <th>Key</th>
	  <th>Challenge</th>
	  <th>Response</th>
	  <th>Date Added</th>
	  <th>Last Edit</th>
	</tr>
	</thead>
	<tbody>
<?php

	if ($_REQUEST['show'] != 'all') {
		$limit = 'LIMIT 10';
	}

	$sql = "SELECT ID, passcode, challenge, response, visible, date_added, date_modified FROM $tablechallenges ORDER BY ID DESC $limit";

	$challenges = $wpdb->get_results($sql);
	if ($challenges) {

		if (count($challenges) > 10 && $_REQUEST['show'] != 'all') {
			$challenges = array_slice($challenges, 0, 10);
		}

		foreach ($challenges as $challenge) {
			$challenge->challenge = stripslashes($challenge->challenge);
			$challenge->response = stripslashes($challenge->response);
			$visible = ($challenge->visible == 'Y') ? 'Yes' : 'No';

			++$i;
			$style = ($i % 2) ? 'alternate ' : '';
			$style .= $visible;

			$add_date = date($date_append, strtotime($challenge->date_added));
			$mod_date = date($date_append, strtotime($challenge->date_modified));
			$mod_date == $add_date ? $mod_date = '-' : '';

			echo <<<CHALLENGES
	<tr class="$style">
		<td class="id">$challenge->ID</td>
		<td class="pass">$challenge->passcode</td>
		<td class="challenge">$challenge->challenge</td>
		<td class="response">$challenge->response</td>
		<td class="adddate">$add_date</td>
		<td class="moddate">$mod_date</td>
CHALLENGES;
			$show_buttons = 1; // default

			if (get_settings('links_use_adminlevels') && ($challenge->user_level > $user_level)) {
			  $show_buttons = 0;
			}

			if ($show_buttons) {
			  echo <<<CHALLENGES
		<td class="action"><a href="gatekeeper.php?action=edit&amp;challenge_id=$challenge->ID" class="edit">Edit</a></td>
		<td class="action"><a href="gatekeeper.php?action=delete&amp;challenge_id=$challenge->ID" onclick="return confirm('You are about to delete this challenge.\\n  \'Cancel\' to stop, \'OK\' to delete.');" class="delete">Delete</a></td>
CHALLENGES;
			} else {
			  echo "<td>&nbsp;</td><td>&nbsp;</td>\n";
			}
		echo "\n\t</tr>";
		}
	}
?>
</tbody>
</table>

</div>

<div class="wrap a">
	<h3><strong>Add</strong> a challenge</h3> 
	<form name="addchallenge" method="post" action="gatekeeper.php">
		<table cellspacing="1">
			<tbody>
			<tr>
				<th scope="row">
					Challenge: 
				</th>
				<td>
					<input type="text" name="challenge" size="60" value=""> 
				</td>
			</tr>
			<tr>
				<th scope="row">
					Response: 
				</th>
				<td>
					<input type="text" name="response" size="60" value=""> 
				</td>
			</tr>
			<tr>
				<th scope="row">
					Activate? 
				</th>
				<td>
					<label> <input type="radio" name="visible" checked="checked" value="Y"> Yes</label> &nbsp; <label> <input type="radio" name="visible" value="N"> No</label> 
				</td>
			</tr>
			</tbody>
		</table>
		<p style="text-align: center;">
			<input type="hidden" name="action" value="add" /> 
			<input type="hidden" name="user_ID" value="<?php echo $user_ID ?>" />
			<input type="submit" name="submit" value="Add Challenge" class="search" />
		</p>
	</form>
</div>

<div class="wrap b">

<h3>Replace keys</h3>
<p>
This will replace all of the keys for all challenges, active and inactive.  If you change the keys while someone is writing a comment, they will be blocked from posting.  As such, it is best to do this only if it is absolutely necessary.
</p>
<p>
<a href="gatekeeper.php?action=newcodes" onclick="return confirm('You are about to replace ALL passcodes with new codes, including challenges that are currently inactive.  You CANNOT undo this operation.\n\n  Click \'Cancel\' to abort.  Click \'OK\' to proceed.');">Generate new keys</a>
</p>

</div>

<?php } // end base display 

if ($_REQUEST['action'] == 'add') {

	$standalone = 1;
	add_action('admin_head','base_styles');
	include_once('admin-header.php');

	$challenge = $HTTP_POST_VARS['challenge'];
	$response = $HTTP_POST_VARS['response'];
	$visible = $HTTP_POST_VARS['visible'];
	$now = date('Y-m-d H:i:s', (time() + (get_settings('time_difference') * 3600)));

	do {
		$pass = rand();
		$passes = $wpdb->query("SELECT ID FROM $tablechallenges WHERE passcode=$pass");
	} while ($passes);

	$wpdb->query("INSERT INTO $tablechallenges (passcode, challenge, response, visible, date_added, date_modified) " .
	" VALUES('" . $pass . "','"
	. addslashes($challenge) . "','"
	. addslashes($response) . "', '"
	. $visible . "', '$now', '$now')");

	header('Location: gatekeeper.php');

} 

if ($_REQUEST['action'] == 'edit') {
	if (isset($_REQUEST['challenge_id'])) {

		$standalone = 0;
		add_action('admin_head','base_styles');
		include_once('admin-header.php');
		$id = $_REQUEST['challenge_id'];
	
		if (!isset($_REQUEST['save_changes'])) {
			$sql = "SELECT ID, passcode, challenge, response, visible, date_modified FROM $tablechallenges WHERE ID='$id'";
			$challenge = $wpdb->get_row($sql);

?>

<div class="wrap">
<h3><strong>Update</strong> challenge</h3>

 <form name="addchallenge" method="post" action="gatekeeper.php?action=update">
	<table cellspacing="1">
		<tbody>
		<tr>
			<th scope="row">
				Challenge: 
			</th>
			<td>
				<input type="text" name="challenge" size="80" value="<?php echo htmlspecialchars(stripslashes($challenge->challenge)); ?>"> 
			</td>
		</tr>
		<tr>
			<th scope="row">
				Response: 
			</th>
			<td>
				<input type="text" name="response" size="80" value="<?php echo htmlspecialchars(stripslashes($challenge->response)); ?>"> 
			</td>
		</tr>
		<tr>
			<th scope="row">
				Key: 
			</th>
			<td>
				<input type="text" name="passcode" size="80" value="<?php echo htmlspecialchars(stripslashes($challenge->passcode)); ?>"> 
			</td>
		</tr>
		<tr>
			<th scope="row">
				Activate? 
			</th>
			<td>
				<label>
		 <input type="radio" name="visible" value="Y" <?php if ($challenge->visible == 'Y') echo 'checked="checked"' ?>>
Yes</label>
&nbsp;
<label>
<input type="radio" name="visible" value="N" <?php if ($challenge->visible == 'N') echo 'checked="checked"' ?>>
No</label> 
			</td>
		</tr>
		</tbody>
	</table>
	<p style="text-align: center;">
		<input type="hidden" name="save_changes" />
		<input type="hidden" name="action" value="update" />
		<input type="hidden" name="challenge_id" value="<?php echo stripslashes($_REQUEST['challenge_id']) ?>" />
		<input type="hidden" name="user_ID" value="<?php echo $user_ID ?>" />
		<input type="submit" name="submit" value="Update Challenge" class="search" />
	</p>

  </form>
</div>

<?php

	 	} else {
			header('Location: gatekeeper.php');
		}
	}
}

if ($_REQUEST['action'] == 'update') {
	if (isset($_REQUEST['challenge_id'])) {

		$challenge_id = $HTTP_POST_VARS['challenge_id'];
		$challenge = $HTTP_POST_VARS['challenge'];
		$response = $HTTP_POST_VARS['response'];
		$visible = $HTTP_POST_VARS['visible'];
		$passcode = $HTTP_POST_VARS['passcode'];
		$now = date('Y-m-d H:i:s', (time() + (get_settings('time_difference') * 3600)));

		$wpdb->query("UPDATE $tablechallenges SET 
		challenge='" . addslashes($challenge) . "',
		response='" . addslashes($response) . "',
		date_modified='" . addslashes($now) . "',
		passcode='" . $passcode . "',
		visible='" . $visible . "' WHERE ID='$challenge_id'");

		header('Location: gatekeeper.php');
	 } else {
		die;	  	
	 }
}

if ($_REQUEST['action'] == 'delete') {
	if (isset($_REQUEST['challenge_id'])) {

		$standalone = 1;
		$challenge_id = $HTTP_GET_VARS["challenge_id"];
		$wpdb->query("DELETE FROM $tablechallenges WHERE ID = $challenge_id");
		header('Location: gatekeeper.php');
	
	}
}

if ($_REQUEST['action'] == 'newcodes') {

	$sql = "SELECT ID, passcode FROM $tablechallenges ORDER BY ID";
	$codes = $wpdb->get_results($sql);
	$limit = count($codes);

	do {
		for ($i = 0; $i < $limit; $i++) {
			$newcode = rand();
			if ($newcode != $codes[$i]->passcode) {
				$newcodes[$i] = $newcode;
				$newids[$i] = $codes[$i]->ID;
			}	
		}
		$filter = array_unique($newcodes);


	} while (count($filter) != count($codes));	

	for ($i = 0; $i < count($newcodes); $i++) {
		$sql = "UPDATE $tablechallenges SET passcode='$newcodes[$i]' WHERE ID='$newids[$i]->ID'";
		$wpdb->query($sql);
		if ($i > 10) die('runaway loop!');
	}

	header('Location: gatekeeper.php');

}
?>

<?php include('admin-footer.php'); ?>