<?php
/*
=========================================================================
Plugin Name: WP Gatekeeper
Version: 1.0
Plugin URI: http://www.meyerweb.com/eric/tools/wordpress/wp-gatekeeper/
Description: Routines to display and check challenge/response pairs for the Gatekeeper anti-spam system.
Author: Eric A. Meyer
Author URI: http://meyerweb.com/
=========================================================================
*/ 

function pose_challenge($format='field label key',$stripslashes='Y',$doctype='xhtml') {

	global $wpdb;
	require ABSPATH . 'wp-config.php';
	$tablechallenges = $table_prefix.'gatekeeper_challenges';

	$sql = "SELECT ID, passcode, challenge, response FROM $tablechallenges WHERE visible = 'Y' ORDER BY ID";
	$challenges = $wpdb->get_results($sql);

	if ($challenges) {
		$cr_count = count($challenges);
		$cr = rand(1,$cr_count) - 1;
		$challenge = $stripslashes == 'Y' ? stripslashes($challenges[$cr]->challenge) : $challenges[$cr]->challenge;
		$closeslash = $doctype == 'xhtml' ? ' /' : '';
		$label = ' <label for="response">' . $challenge . '</label> ';
		$field = ' <input name="response" id="response" type="text" value=""' . $closeslash . '> ';
		$key= ' <input name="key" type="hidden" value="' . $challenges[$cr]->passcode . '"' . $closeslash . '> ';
	
		$result = $format;
		$result = str_replace('label',$label,$result);
		$result = str_replace('field',$field,$result);
		$result = str_replace('key',$key,$result);
		echo $result;	
	} else {
		echo '<strong>WP-Gatekeeper failure: no challenges are active.  The problem can only be fixed by the administrator of this WordPress install.  Posting will be impossible until this is resolved.</strong>';
	}
}

function run_gauntlet($key,$answer) {

	global $wpdb;
	require ABSPATH . 'wp-config.php';
	$tablechallenges = $table_prefix.'gatekeeper_challenges';

	$answer = stripslashes($answer);
	$sql = "SELECT response FROM $tablechallenges WHERE passcode='$key'";
	$answers = $wpdb->get_results($sql);

	if ($answers && strcasecmp(stripslashes($answers[0]->response),$answer) == 0) {
		return true;
	}
	return false;

}